// H4CK TH3 PL4NET!

 

package com.google.android.gcm;

import android.app.*;
import android.content.*;
import android.os.PowerManager;
import android.os.SystemClock;
import android.util.Log;
import java.util.Random;
import java.util.concurrent.TimeUnit;

// Referenced classes of package com.google.android.gcm:
//            GCMRegistrar

public abstract class GCMBaseIntentService extends IntentService
{

    protected GCMBaseIntentService()
    {
        StringBuilder stringbuilder = new StringBuilder("GCMIntentService--");
        int i = d + 1;
        d = i;
        String s = stringbuilder.append(i).toString();
        super(s);
    }

    static void a(Context context, Intent intent, String s)
    {
        int i;
        Intent intent1;
        android.content.ComponentName componentname;
        synchronized(c)
        {
            if(b == null)
                b = ((PowerManager)context.getSystemService("power")).newWakeLock(1, "GCM_LIB");
        }
        i = Log.v("GCMBaseIntentService", "Acquiring wakelock");
        b.acquire();
        intent1 = intent.setClassName(context, s);
        componentname = context.startService(intent);
    }

    protected void a()
    {
    }

    protected abstract void a(Context context, Intent intent);

    protected abstract void a(Context context, String s);

    protected abstract void b(Context context, String s);

    protected abstract void c(Context context, String s);

    protected boolean d(Context context, String s)
    {
        return true;
    }

    public final void onHandleIntent(Intent intent)
    {
        Object obj;
        String s;
        obj = getApplicationContext();
        s = intent.getAction();
        if(!s.equals("com.google.android.c2dm.intent.REGISTRATION")) goto _L2; else goto _L1
_L1:
        String s1;
        String s2;
        s = intent.getStringExtra("registration_id");
        s1 = intent.getStringExtra("error");
        s2 = intent.getStringExtra("unregistered");
        String s3 = (new StringBuilder("handleRegistration: registrationId = ")).append(s).append(", error = ").append(s1).append(", unregistered = ").append(s2).toString();
        int i = Log.d("GCMBaseIntentService", s3);
        if(s == null) goto _L4; else goto _L3
_L3:
        GCMRegistrar.g(((Context) (obj)));
        String s4 = GCMRegistrar.a(((Context) (obj)), s);
        a(((Context) (obj)), s);
_L9:
        s = ((String) (c));
        s;
        JVM INSTR monitorenter ;
        if(b == null) goto _L6; else goto _L5
_L5:
        int j = Log.v("GCMBaseIntentService", "Releasing wakelock");
        b.release();
_L22:
        return;
_L4:
        if(s2 == null) goto _L8; else goto _L7
_L7:
        GCMRegistrar.g(((Context) (obj)));
        String s5 = GCMRegistrar.f(((Context) (obj)));
        b(((Context) (obj)), s5);
          goto _L9
        s;
        obj = c;
        obj;
        JVM INSTR monitorenter ;
        if(b == null) goto _L11; else goto _L10
_L10:
        int k = Log.v("GCMBaseIntentService", "Releasing wakelock");
        b.release();
_L23:
        throw s;
_L8:
        String s6 = (new StringBuilder("Registration error: ")).append(s1).toString();
        int l = Log.d("GCMBaseIntentService", s6);
        int k2;
        if("SERVICE_NOT_AVAILABLE".equals(s1))
        {
            if(d(((Context) (obj)), s1))
            {
                s = GCMRegistrar.h(((Context) (obj)));
                int i1 = s / 2;
                int j1 = e.nextInt(s);
                int k1 = i1 + j1;
                String s7 = (new StringBuilder("Scheduling registration retry, backoff = ")).append(k1).append(" (").append(s).append(")").toString();
                int l1 = Log.d("GCMBaseIntentService", s7);
                Intent intent1 = new Intent("com.google.android.gcm.intent.RETRY");
                String s8 = g;
                Intent intent2 = intent1.putExtra("token", s8);
                PendingIntent pendingintent = PendingIntent.getBroadcast(((Context) (obj)), 0, intent1, 0);
                AlarmManager alarmmanager = (AlarmManager)((Context) (obj)).getSystemService("alarm");
                long l2 = SystemClock.elapsedRealtime();
                long l3 = k1;
                long l4 = l2 + l3;
                alarmmanager.set(3, l4, pendingintent);
                int i2 = f;
                if(s < i2)
                {
                    int j2 = s * 2;
                    GCMRegistrar.a(((Context) (obj)), j2);
                }
            } else
            {
                k2 = Log.d("GCMBaseIntentService", "Not retrying failed operation");
            }
        } else
        {
            c(((Context) (obj)), s1);
        }
          goto _L9
_L2:
        if(!s.equals("com.google.android.c2dm.intent.RECEIVE")) goto _L13; else goto _L12
_L12:
        s = intent.getStringExtra("message_type");
        if(s == null) goto _L15; else goto _L14
_L14:
        if(!s.equals("deleted_messages")) goto _L17; else goto _L16
_L16:
        String s9 = intent.getStringExtra("total_deleted");
        s = s9;
        if(s == null) goto _L9; else goto _L18
_L18:
        int i3 = Integer.parseInt(s);
        String s10 = (new StringBuilder("Received deleted messages notification: ")).append(i3).toString();
        int j3 = Log.v("GCMBaseIntentService", s10);
        a();
          goto _L9
        NumberFormatException numberformatexception;
        numberformatexception;
        String s11 = (new StringBuilder("GCM returned invalid number of deleted messages: ")).append(s).toString();
        int k3 = Log.e("GCMBaseIntentService", s11);
          goto _L9
_L17:
        String s12 = (new StringBuilder("Received unknown special message: ")).append(s).toString();
        int i4 = Log.e("GCMBaseIntentService", s12);
          goto _L9
_L15:
        s = null;
        if(((Context) (obj)).getSharedPreferences("com.google.android.c2dm", 0).getBoolean("dm_lightson", false))
        {
            s = ((PowerManager)getSystemService("power")).newWakeLock(0x10000006, "GCM_MESSAGE_ALERT_LOCK");
            s.acquire();
        }
        a(((Context) (obj)), intent);
        if(s != null)
            s.release();
          goto _L9
_L13:
        if(!s.equals("com.google.android.gcm.intent.RETRY")) goto _L9; else goto _L19
_L19:
        s = intent.getStringExtra("token");
        if(g.equals(s)) goto _L21; else goto _L20
_L20:
        String s13 = (new StringBuilder("Received invalid token: ")).append(s).toString();
        int j4 = Log.e("GCMBaseIntentService", s13);
        s = ((String) (c));
        s;
        JVM INSTR monitorenter ;
        if(b == null)
            break MISSING_BLOCK_LABEL_743;
        int k4 = Log.v("GCMBaseIntentService", "Releasing wakelock");
        b.release();
          goto _L22
        obj;
        s;
        JVM INSTR monitorexit ;
        throw obj;
        Exception exception2;
        exception2;
          goto _L22
        int i5 = Log.e("GCMBaseIntentService", "Wakelock reference is null");
          goto _L22
_L21:
        if(GCMRegistrar.e(((Context) (obj))))
        {
            GCMRegistrar.c(((Context) (obj)));
        } else
        {
            String as[] = new String[1];
            String s14 = a;
            as[0] = s14;
            GCMRegistrar.b(((Context) (obj)), as);
        }
          goto _L9
_L11:
        int j5 = Log.e("GCMBaseIntentService", "Wakelock reference is null");
          goto _L23
        Exception exception1;
        exception1;
        obj;
        JVM INSTR monitorexit ;
        throw exception1;
        Exception exception3;
        exception3;
          goto _L23
_L6:
        int k5 = Log.e("GCMBaseIntentService", "Wakelock reference is null");
          goto _L22
        Exception exception;
        exception;
        s;
        JVM INSTR monitorexit ;
        throw exception;
        Exception exception4;
        exception4;
          goto _L22
    }

    private static android.os.PowerManager.WakeLock b;
    private static final Object c = com/google/android/gcm/GCMBaseIntentService;
    private static int d = 0;
    private static final Random e;
    private static final int f;
    private static final String g;
    protected String a;

    static 
    {
        e = new Random();
        f = (int)TimeUnit.SECONDS.toMillis(3600L);
        g = Long.toBinaryString(e.nextLong());
    }
}
