// H4CK TH3 PL4NET!

 

package com.google.android.gcm;

import android.app.PendingIntent;
import android.content.*;
import android.content.pm.*;
import android.util.Log;
import java.util.*;

public final class GCMRegistrar
{

    private GCMRegistrar()
    {
        throw new UnsupportedOperationException();
    }

    static String a(Context context, String s)
    {
        SharedPreferences sharedpreferences = context.getSharedPreferences("com.google.android.gcm", 0);
        String s1 = sharedpreferences.getString("regId", "");
        int j = i(context);
        String s2 = (new StringBuilder("Saving regId on app version ")).append(j).toString();
        int k = Log.v("GCMRegistrar", s2);
        android.content.SharedPreferences.Editor editor = sharedpreferences.edit();
        android.content.SharedPreferences.Editor editor1 = editor.putString("regId", s);
        android.content.SharedPreferences.Editor editor2 = editor.putInt("appVersion", j);
        boolean flag = editor.commit();
        return s1;
    }

    public static void a(Context context)
    {
        int j = android.os.Build.VERSION.SDK_INT;
        if(j < 8)
        {
            String s = (new StringBuilder("Device must be at least API Level 8 (instead of ")).append(j).append(")").toString();
            throw new UnsupportedOperationException(s);
        }
        PackageManager packagemanager = context.getPackageManager();
        try
        {
            PackageInfo packageinfo = packagemanager.getPackageInfo("com.google.android.gsf", 0);
            return;
        }
        catch(android.content.pm.PackageManager.NameNotFoundException namenotfoundexception)
        {
            throw new UnsupportedOperationException("Device does not have package com.google.android.gsf");
        }
    }

    static void a(Context context, int j)
    {
        android.content.SharedPreferences.Editor editor = context.getSharedPreferences("com.google.android.gcm", 0).edit();
        android.content.SharedPreferences.Editor editor1 = editor.putInt("backoff_ms", j);
        boolean flag = editor.commit();
    }

    private static void a(Context context, Set set, String s)
    {
        PackageManager packagemanager = context.getPackageManager();
        String s1 = context.getPackageName();
        Intent intent = new Intent(s);
        Intent intent1 = intent.setPackage(s1);
        Object obj = packagemanager.queryBroadcastReceivers(intent, 32);
        if(((List) (obj)).isEmpty())
        {
            String s2 = (new StringBuilder("No receivers for action ")).append(s).toString();
            throw new IllegalStateException(s2);
        }
        if(Log.isLoggable("GCMRegistrar", 2))
        {
            StringBuilder stringbuilder = new StringBuilder("Found ");
            int j = ((List) (obj)).size();
            String s3 = stringbuilder.append(j).append(" receivers for action ").append(s).toString();
            int k = Log.v("GCMRegistrar", s3);
        }
        obj = ((List) (obj)).iterator();
        String s4;
        do
        {
            if(!((Iterator) (obj)).hasNext())
                return;
            s4 = ((ResolveInfo)((Iterator) (obj)).next()).activityInfo.name;
        } while(set.contains(s4));
        String s5 = (new StringBuilder("Receiver ")).append(s4).append(" is not set with permission com.google.android.c2dm.permission.SEND").toString();
        throw new IllegalStateException(s5);
    }

    public static void a(Context context, boolean flag)
    {
        SharedPreferences sharedpreferences = context.getSharedPreferences("com.google.android.gcm", 0);
        String s = (new StringBuilder("Setting registered on server status as: ")).append(flag).toString();
        int j = Log.v("GCMRegistrar", s);
        android.content.SharedPreferences.Editor editor = sharedpreferences.edit();
        android.content.SharedPreferences.Editor editor1 = editor.putBoolean("onServer", flag);
        boolean flag1 = editor.commit();
    }

    public static transient void a(Context context, String as[])
    {
        g(context);
        b(context, as);
    }

    public static void b(Context context)
    {
        Object obj = null;
        PackageManager packagemanager = context.getPackageManager();
        Object obj1 = context.getPackageName();
        String s = String.valueOf(obj1);
        String s1 = (new StringBuilder(s)).append(".permission.C2D_MESSAGE").toString();
        ActivityInfo aactivityinfo[];
        android.content.pm.PermissionInfo permissioninfo;
        PackageInfo packageinfo;
        try
        {
            permissioninfo = packagemanager.getPermissionInfo(s1, 4096);
        }
        catch(android.content.pm.PackageManager.NameNotFoundException namenotfoundexception)
        {
            String s3 = (new StringBuilder("Application does not define permission ")).append(s1).toString();
            throw new IllegalStateException(s3);
        }
        s1 = 2;
        try
        {
            packageinfo = packagemanager.getPackageInfo(((String) (obj1)), s1);
        }
        catch(android.content.pm.PackageManager.NameNotFoundException namenotfoundexception1)
        {
            String s4 = (new StringBuilder("Could not get receivers for package ")).append(((String) (obj1))).toString();
            throw new IllegalStateException(s4);
        }
        aactivityinfo = packageinfo.receivers;
        if(aactivityinfo == null || aactivityinfo.length == 0)
        {
            String s2 = (new StringBuilder("No receiver for package ")).append(((String) (obj1))).toString();
            throw new IllegalStateException(s2);
        }
        if(Log.isLoggable("GCMRegistrar", 2))
        {
            StringBuilder stringbuilder = (new StringBuilder("number of receivers for ")).append(((String) (obj1))).append(": ");
            int k = aactivityinfo.length;
            String s5 = stringbuilder.append(k).toString();
            int l = Log.v("GCMRegistrar", s5);
        }
        obj1 = new HashSet();
        int j = aactivityinfo.length;
        int i1 = 0;
        do
        {
            ActivityInfo activityinfo;
            String s6;
            if(i1 >= j)
                if(((Set) (obj1)).isEmpty())
                {
                    throw new IllegalStateException("No receiver allowed to receive com.google.android.c2dm.permission.SEND");
                } else
                {
                    a(context, ((Set) (obj1)), "com.google.android.c2dm.intent.REGISTRATION");
                    a(context, ((Set) (obj1)), "com.google.android.c2dm.intent.RECEIVE");
                    return;
                }
            activityinfo = aactivityinfo[i1];
            s6 = activityinfo.permission;
            if("com.google.android.c2dm.permission.SEND".equals(s6))
            {
                String s7 = activityinfo.name;
                boolean flag = ((Set) (obj1)).add(s7);
            }
            i1++;
        } while(true);
    }

    static transient void b(Context context, String as[])
    {
        if(as == null || as.length == 0)
            throw new IllegalArgumentException("No senderIds");
        String s = as[0];
        StringBuilder stringbuilder = new StringBuilder(s);
        int j = 1;
        do
        {
            int k = as.length;
            if(j >= k)
            {
                String s1 = stringbuilder.toString();
                StringBuilder stringbuilder1 = new StringBuilder("Registering app ");
                String s2 = context.getPackageName();
                String s3 = stringbuilder1.append(s2).append(" of senders ").append(s1).toString();
                int l = Log.v("GCMRegistrar", s3);
                Intent intent = new Intent("com.google.android.c2dm.intent.REGISTER");
                Intent intent1 = intent.setPackage("com.google.android.gsf");
                Intent intent2 = new Intent();
                PendingIntent pendingintent = PendingIntent.getBroadcast(context, 0, intent2, 0);
                Intent intent3 = intent.putExtra("app", pendingintent);
                Intent intent4 = intent.putExtra("sender", s1);
                android.content.ComponentName componentname = context.startService(intent);
                return;
            }
            StringBuilder stringbuilder2 = stringbuilder.append(',');
            String s4 = as[j];
            StringBuilder stringbuilder3 = stringbuilder2.append(s4);
            j++;
        } while(true);
    }

    static void c(Context context)
    {
        StringBuilder stringbuilder = new StringBuilder("Unregistering app ");
        String s = context.getPackageName();
        String s1 = stringbuilder.append(s).toString();
        int j = Log.v("GCMRegistrar", s1);
        Intent intent = new Intent("com.google.android.c2dm.intent.UNREGISTER");
        Intent intent1 = intent.setPackage("com.google.android.gsf");
        Intent intent2 = new Intent();
        PendingIntent pendingintent = PendingIntent.getBroadcast(context, 0, intent2, 0);
        Intent intent3 = intent.putExtra("app", pendingintent);
        android.content.ComponentName componentname = context.startService(intent);
    }

    public static String d(Context context)
    {
        SharedPreferences sharedpreferences = context.getSharedPreferences("com.google.android.gcm", 0);
        String s = sharedpreferences.getString("regId", "");
        int j = sharedpreferences.getInt("appVersion", 0x80000000);
        int k = i(context);
        String s1;
        if(j != 0x80000000 && j != k)
        {
            String s2 = (new StringBuilder("App version changed from ")).append(j).append(" to ").append(k).append("; resetting registration id").toString();
            int l = Log.v("GCMRegistrar", s2);
            String s3 = a(context, "");
            s1 = "";
        } else
        {
            s1 = s;
        }
        return s1;
    }

    public static boolean e(Context context)
    {
        boolean flag;
        if(d(context).length() > 0)
            flag = true;
        else
            flag = false;
        return flag;
    }

    static String f(Context context)
    {
        return a(context, "");
    }

    static void g(Context context)
    {
        StringBuilder stringbuilder = new StringBuilder("resetting backoff for ");
        String s = context.getPackageName();
        String s1 = stringbuilder.append(s).toString();
        int j = Log.d("GCMRegistrar", s1);
        a(context, 3000);
    }

    static int h(Context context)
    {
        return context.getSharedPreferences("com.google.android.gcm", 0).getInt("backoff_ms", 3000);
    }

    private static int i(Context context)
    {
        int j;
        try
        {
            PackageManager packagemanager = context.getPackageManager();
            String s = context.getPackageName();
            j = packagemanager.getPackageInfo(s, 0).versionCode;
        }
        catch(android.content.pm.PackageManager.NameNotFoundException namenotfoundexception)
        {
            String s1 = (new StringBuilder("Coult not get package name: ")).append(namenotfoundexception).toString();
            throw new RuntimeException(s1);
        }
        return j;
    }
}
